
# 一、demo运行说明

### 替换项目中宏定义

```
#define QiNiuToken   @"从后台获取toekn"
#define nameSpaceId  @"空间ID"
#define deviceId     @"设备国标ID"
```



#	二、主要代码


## 录制音频文件

```
    self.microPhone = [[QRDMicrophoneSource alloc] init];
    self.microPhone.delegate = self;
  //开始录制
  [self.microPhone startRunning];
```
 ## 获取PCM


```
//获取pcm数据
- (void)microphoneSource:(QRDMicrophoneSource *)source didGetAudioBuffer:(AudioBuffer *)audioBuffer {
    
    int length = audioBuffer->mDataByteSize;
    
    if(length+pcmWriteOffset <= bufferLength){
        memcpy(buffer + pcmWriteOffset, audioBuffer->mData, audioBuffer->mDataByteSize);
        pcmWriteOffset += length;
    } else {
        //buffer不够存放pcm数据 需要从头部开始
        //末尾剩余长度
        size_t endSize = bufferLength - pcmWriteOffset;
        //超出的长度
        size_t outSize = length + pcmWriteOffset - bufferLength;
        memcpy(buffer + pcmWriteOffset, audioBuffer->mData, endSize);
        pcmWriteOffset = 0;
        memcpy(buffer + pcmWriteOffset, (char *)(audioBuffer->mData) + endSize, outSize);
        pcmWriteOffset += outSize;
    }
}

- (NSData *)readPcm {
    if (pcmReadOffset == pcmWriteOffset == 0 && !self.microPhone.isRunning) {
        return nil;
    }
    
    if (pcmWriteOffset > pcmReadOffset) {
        NSUInteger size = pcmWriteOffset - pcmReadOffset;
        NSData * data = [NSData dataWithBytes:buffer + pcmReadOffset length:size];
        pcmReadOffset += size;
        return data;
    } else {
        NSUInteger size1 = bufferLength - pcmReadOffset;
        NSData *data1 = [NSData dataWithBytes:buffer + pcmReadOffset length:size1];
        pcmReadOffset = 0;
        NSUInteger size2  = pcmWriteOffset;
        NSData *data2 = [NSData dataWithBytes:buffer length:size2];
        pcmReadOffset += size2;
        NSMutableData *muteData = [[NSMutableData alloc] init];
        [muteData appendData:data1];
        [muteData appendData:data2];
        return muteData;
    }
}

```


 

## PCM 转成 G711a


```
// pcm转成g711a
// pcm 的采样率 8k  16bit
// g711a 采样率 8k  8bit
- (NSData *)Pcm2G711a:(NSData *)pcmData { 
    char *pcmCdata = (char *)[pcmData bytes];
    char *g711data = malloc(pcmData.length/2);
    pcm16_alaw_tableinit();
    pcm16_to_alaw((int)pcmData.length, pcmCdata, g711data);
    
    NSData *data = [NSData dataWithBytes:g711data length:pcmData.length/2];
    NSString *path = [NSTemporaryDirectory() stringByAppendingString:@"recording.g711"];
    
    if([[NSFileManager defaultManager] fileExistsAtPath:path]) {
        [[NSFileManager defaultManager] removeItemAtPath:path error:nil];
    }
    [data writeToFile:path atomically:YES]; 
    
    return data;
}

```

